#ifndef __SLIDESCALE_H__
#define __SLIDESCALE_H__

#include "slidetransform.h"

//////////////////////////////////////////////////////////////////////
// CSLIDEScale Class
//

class CSLIDEScale : public CSLIDETransform
{
//////////////////////////////////////////////////
// Enumerated Types
//

//////////////////////////////////////////////////
// Initialization
//
public:
  CSLIDEScale();
  virtual ~CSLIDEScale();
  virtual VOID Init(CHAR *pcFile, UINT_32 uiLine, UINT_32 uiColumn, 
		    DynVector *pdynv);
  virtual VOID Uninit();

  virtual BOOL Initialized();

  virtual BOOL CheckSemantics(CSLIDEWorld *pCSLIDEWorld);

  virtual BOOL Valid();

//////////////////////////////////////////////////
// Geometric Computations
//
public:

protected:
////////////////////////////////////////////////////////////////////////
// START: ASSIGNMENT 3: These are the methods you will be dealing with
// 
  virtual VOID CheckDynamic();
  virtual VOID UpdateState();
// 
// END  : ASSIGNMENT 3: These are the methods you will be dealing with
////////////////////////////////////////////////////////////////////////

//////////////////////////////////////////////////
// Rendering
//
public:

//////////////////////////////////////////////////
// Output Functions
//
public:
  virtual VOID WriteSLIDE(FILE *fpOutputFile);

//////////////////////////////////////////////////
// Accessor Functions
//
public:

//////////////////////////////////////////////////
// Class Variables
//
public:

//////////////////////////////////////////////////
// Member Variables
//
protected:
  DynVector m_vScale;
};

//////////////////////////////////////////////////////////////////////
// Inlined Functions
//

#endif // __SLIDESCALE_H__


